﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win.Touch;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace TouchSample
{


    public partial class Form1 : Form
    {

        protected override void WndProc(ref Message m)
        {
            // Decode and handle WM_TOUCH message.
            bool handled;
            switch (m.Msg)
            {

                case 0X0240:    //WM_TOUCH
                    //handled = DecodeTouch(ref m);
                    break;
                default:
                    handled = false;
                    break;
            }

            // Call parent WndProc for default message processing.
            base.WndProc(ref m);

            //if (handled)
            //{
            //    // Acknowledge event if handled.
            //    m.Result = new System.IntPtr(1);
            //}
        }


        public Form1()
        {
            InitializeComponent();
            Infragistics.Win.AppStyling.StyleManager.Load("../../IG.isl");
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = GetData();


            //Bind DataSet
            this.ultraTree1.DataSource = GetDataForTree();
        }



        private DataSet GetData()
        {
            // ************************
            // Create DataSet
            // ************************
            //Create DataSet
            DataSet dsSample1 = new DataSet();

            //Create DataTable
            DataTable dtSample1 = dsSample1.Tables.Add("Sample");

            //Create Columns
            dtSample1.Columns.Add("Check", typeof(System.Boolean));
            dtSample1.Columns.Add("String", typeof(System.String));
            dtSample1.Columns.Add("Number", typeof(System.Int32));

            //Create Rows
            for (int index = 100; index <= 1100; index++)
            {
                dtSample1.Rows.Add(new object[] {
                                                    false,
                                                    "String_" + index.ToString(),
                                                    index,
                                                });
            }
            dtSample1.PrimaryKey = new DataColumn[] { dtSample1.Columns["Number"] };
            dsSample1.AcceptChanges();

            return dsSample1;
        }


        private DataSet GetDataForTree()
        {

            //Create DataSet
            DataSet dsSample1 = new DataSet();

            //Create DataTable
            DataTable dtSample1 = dsSample1.Tables.Add("Sample_parent");
            DataTable dtSample2 = dsSample1.Tables.Add("Sample_child");

            //Create Columns
            dtSample1.Columns.Add("Number", typeof(System.String));
            dtSample1.Columns.Add("Data", typeof(System.String));
            dtSample2.Columns.Add("Number", typeof(System.String));
            dtSample2.Columns.Add("Memo", typeof(System.String));

            //Create Rows
            for (int index = 1; index <= 10; index++)
            {
                dtSample1.Rows.Add(new string[] {
				                                    index.ToString(),
				                                    "Data" + index.ToString()
			                                    });
                dtSample2.Rows.Add(new string[] {
				                                    index.ToString(),
				                                    "Memo" + index.ToString() + "-1"
			                                    });
                dtSample2.Rows.Add(new string[] {
				                                    index.ToString(),
				                                    "Memo" + index.ToString() + "-2"
			                                    });
            }

            //Create Relations(Parent-Child)
            dtSample1.ChildRelations.Add(dtSample1.Columns["Number"], dtSample2.Columns["Number"]);
            dsSample1.AcceptChanges();

            return dsSample1;
        }

        private void ultraButton1_GestureQueryStatus(object sender, Infragistics.Win.Touch.GestureQueryStatusEventArgs e)
        {

        }

        private void ultraGrid1_GestureQueryStatus(object sender, Infragistics.Win.Touch.GestureQueryStatusEventArgs e)
        {

        }

        private void ultraGrid1_GestureStarting(object sender, Infragistics.Win.Touch.GestureStartingEventArgs e)
        {

        }

        private void ultraGrid1_PanGesture(object sender, Infragistics.Win.Touch.PanGestureEventArgs e)
        {
            Debug.WriteLine("ultraGrid1_PanGesture: " + e.Gesture.ToString());
            //慣性ジェスチャをキャンセルする。
            if (e.IsInertial == true)
            {
                e.Handled = true;
            }
        }

        private void ultraGrid1_GiveFeedback(object sender, GiveFeedbackEventArgs e)
        {

        }

        private Point p = new Point(0, 0);      //GestureCompleted時のタッチ位置保持用
        private Boolean isPressAndHold = false; //PressAndHoldの場合のみTrueに設定
        //GestureCompletedイベント
        private void ultraGrid1_GestureCompleted(object sender, Infragistics.Win.Touch.GestureCompletedEventArgs e)
        {
            //ジェスチャの種類を判定
            if (e.Gesture.Equals(Gesture.PressAndHold))
            {
                //タッチフラグをOnに設定
                isPressAndHold = true;
                //タッチ位置を保持する
                p = e.Location;

            }
        }

        //Clickイベント
        private void ultraGrid1_Click(object sender, EventArgs e)
        {
            //PressAndHold時のクリックかどうかを判定
            if (isPressAndHold)
            {
                //タッチ座標からエレメントを取得
                UIElement element = ultraGrid1.DisplayLayout.UIElement.ElementFromPoint(p);
                UltraGridCell cell = element.GetContext(typeof(UltraGridCell)) as UltraGridCell;
                //取得したエレメントがセルかどうかの判定
                if (cell != null)
                {
                    //長押しされたElementがCellだった場合、文字色を赤へ変更
                    cell.Appearance.ForeColor = Color.Red;
                }
            }
            //フラグの初期化
            isPressAndHold = false;
        }


        private void ultraButton2_Click(object sender, EventArgs e)
        {
            //タッチサポートの切り替え
            if (this.ultraTouchProvider1.Enabled)
            {
                this.ultraTouchProvider1.Enabled = false;
            }
            else
            {
                this.ultraTouchProvider1.Enabled = true;
            }

        }

        private void ultraGrid1_PressAndHoldGesture(object sender, PressAndHoldGestureEventArgs e)
        {

        }
    }
}
